----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    22:23:31 09/24/2006 
-- Design Name: 
-- Module Name:    ssg - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ssg_driver is
    Port ( mclk : in  STD_LOGIC;
           sum : in  STD_LOGIC_VECTOR (3 downto 0);
			  overflow : in std_logic;
           an : out  STD_LOGIC_VECTOR (1 downto 0);
           ssg : out  STD_LOGIC_VECTOR (6 downto 0));
end ssg_driver;

architecture Behavioral of ssg_driver is
	signal dig1 : std_logic_vector(6 downto 0);
	signal dig2 : std_logic_vector(6 downto 0);
	signal clkdiv : std_logic_vector(1 downto 0);
begin
  -- encode the minus
  dig1 <= "1000000" when sum(3) = '1' else
	       "0111111"; 
	
  -- encode digits 0 to 7 and neg 8 to neg 1
  dig2 <= "0111111" when sum = "0000" else
		   "0000110" when sum = "0001" else
		   "1011011" when sum = "0010" else
		   "1001111" when sum = "0011" else
		   "1100110" when sum = "0100" else
		   "1101101" when sum = "0101" else
		   "1111101" when sum = "0110" else
		   "0000111" when sum = "0111" else
		   "1111111" when sum = "1000" else -- neg 8
		   "0000111" when sum = "1001" else -- neg 7
         "1111101" when sum = "1010" else
         "1101101" when sum = "1011" else
         "1100110" when sum = "1100" else
         "1001111" when sum = "1101" else
         "1011011" when sum = "1110" else
         "0000110" when sum = "1111" else
		   "0000000";

	-- Divide the master clock down to a lower frequency.

	process (mclk)
		begin
			if (mclk = '1' and mclk'Event) then
				clkdiv <= clkdiv + 1;
				if (clkdiv(0) = '1') then
				   if (overflow = '0') then
					   ssg <= dig1;
					else
						ssg <= "0111111";
					end if;
				   --ssg <= dig1;
					an(0) <= '1';
			      an(1) <= '0';
				else
					--ssg <= dig2;
					if (overflow = '0') then
					  ssg <= dig2;
					else
					  ssg <= "0111110";
					end if;
					an(0) <= '0';
					an(1) <= '1';
				end if;
			end if;
		end process;

end Behavioral;

